--Laser Gun example mod was used to create this tool!
-- 1/06/2021

function init()
	--Register tool and enable it
	RegisterTool("flamethrower", "Flamethrower", "MOD/vox/flamethrower.vox")
	SetBool("game.tool.flamethrower.enabled", true)

	--Flamethrower has 30 seconds of ammo. 
	SetFloat("game.tool.flamethrower.ammo", 120) -- set ammo
	
	ready = 0
	fireTime = 0
	
	burnSnd = LoadLoop("MOD/snd/burn.ogg")
	blastSnd = LoadSound("MOD/snd/blast.ogg")
end

--Return a random vector of desired length
function rndVec(length)
	local v = VecNormalize(Vec(math.random(-100,100), math.random(-100,100), math.random(-100,100)))
	return VecScale(v, length)	
end

function tick(dt)
	--Check if the tool is equipped
	if GetString("game.player.tool") == "flamethrower" then
		
		SetToolTransform(Transform(Vec(0.3, -0.3, -0.4)))
		
		--Check if tool is firing
		if GetBool("game.player.canusetool") and InputDown("usetool") and GetFloat("game.tool.flamethrower.ammo") > 0 then
			if ready == 0 then 
				PlaySound(blastSnd)
			end
			ready = math.min(1.0, ready + dt*4)
			if ready == 1.0 then
				PlayLoop(burnSnd)
				local t = GetCameraTransform()
				local fwd = TransformToParentVec(t, Vec(0, 0, -2))
				local fwd2 = TransformToParentVec(t, Vec(.3, 0, -2))
				local maxDist = 5
				local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, maxDist)
				if not hit then
					dist = maxDist
				end
				
				--Line start and end points
				local s = VecAdd(VecAdd(t.pos, Vec(0, -0.5, 0)),VecScale(fwd2, 1.5))
				local e = VecAdd(t.pos, VecScale(fwd, dist))
				
				local last = s
				for i=1, 10 do
					local t = i/10
					local p = VecLerp(s, e, t)
					SpawnParticle("fire", last, rndVec(0.5), 0.5, 0.5)
					SpawnFire(last)
					p = VecAdd(p, rndVec(0.35*t))
					last = p
				end

				--Make damage and spawn particles
				if hit then
					PlayLoop(hitSnd, e)
					SpawnFire(e)
					SpawnParticle("fire", e, rndVec(0.5), 0.5, 0.5)
					--SpawnParticle("smoke", e, rndVec(0.5), 1.0, 1.0)
				end
				
				fireTime = fireTime + dt
				SetFloat("game.tool.flamethrower.ammo", math.max(0, GetFloat("game.tool.flamethrower.ammo")-dt))
				
				--Provide ammo display with one decimal
				SetString("game.tool.flamethrower.ammo.display", math.floor(GetFloat("game.tool.flamethrower.ammo")*10)/10)
			end
		else
			fireTime = 0
			ready = math.max(0.0, ready - dt*4)
		end
	end
end

